//Sarah Bass	

#include <stdio.h>
#include <wfdb/ecgcodes.h>
#include <wfdb/wfdb.h>


struct sample {
    struct sample *below; /* points to lower neighbor (next signal) */
    struct sample *next; /* pointers to neighbor (in time) */
    WFDB_Time time;	/* time of sample */
    int amp;	 /* value of signal at time of sample */
};
typedef struct sample Sample;

long* annotations;
WFDB_Annotation annot, annot2;
WFDB_Anninfo aTraining[1];
int mode = 0;
long annNum =0;
long* annotationsBp;
WFDB_Sample *v;
WFDB_Siginfo *s;
int nsig;
int signum = 0;
Sample *sigHead, *sigTail, *maxHead, *maxTail;
int* bpAtMax;
int* max, * min;
int* delay;
long* curMax;
char* record;
long* sum;
long* meanCount;
long currentTime = 0;
long* numMax;
long annIndex = 0;
double maxCount = 0;
int bpSig=-1;
FILE* fin;
int* original;
long* bpSignal;
long* template;
long** templateList;
int finalTempInd = 0;
int* finalTempLength;
long* refAnns;
int numTemplates = -1;
int sampfrq = 250;
void compareBeats();
void annotateBeats(WFDB_Time time);
void readBp();
void createTemplate(long start, long end);
void findDistance(long templateLength);


int main(int argc, char **argv1)
{
	long i, j;
	int ann;
	WFDB_Anninfo a[2];
	fin = fopen("templates.csv", "r");
	//WFDB_Anninfo aTraining[1];
	annotations = (WFDB_Time*)calloc(138000, sizeof(WFDB_Time));
	templateList = (long**)calloc(100*10, sizeof(long*));
	finalTempLength = (int*)calloc(100*10, sizeof(int));
//	printf("reading\n");
	i=0;

	
	while(!feof(fin))
	{
		
		
		fscanf(fin, "%d,", &finalTempLength[numTemplates+1]);
		templateList[numTemplates+1] = (long*)calloc(finalTempLength[numTemplates+1], sizeof(long));
		for(j=0; j<finalTempLength[numTemplates+1]; j++)
		{
			fscanf(fin, "%d,", templateList[numTemplates+1]+j);
		}
		numTemplates++;
			//printf("%d\n", rec);
		
		//printf("\n");
		i++;
		

	}
	//printf("%d\n", *(templateList[0]));
	fclose(fin);
	record = argv1[2];
//	a[1].name = "atr"; a[1].stat = WFDB_READ;


	a[0].name = "qrs"; a[0].stat = WFDB_WRITE;
	



	char** argv = (char**)calloc(3, sizeof(char*));
	argv[0] = "gqrs.c";
	argv[1] = "-r";
	argv[2] = record;
	findBeats(3, argv, &annotations);
	printf("\n");
	//printf("%ld ", annotations[0]);
	
	
	s = (WFDB_Siginfo *)calloc(nsig, sizeof(WFDB_Siginfo));

		
	
	annotationsBp = (WFDB_Time*)calloc(18750, sizeof(WFDB_Time));
//	refAnns = (long*)calloc(18750, sizeof(long));
	bpSignal = (long*)calloc(10*sampfrq*60, sizeof(long));
	ann = annopen(record, a, 1);
	if (isigopen(record, s, nsig) != nsig)
	exit(1);
	setifreq(sampfrq);
	//s[1].desc = "ABP";
	i=1; 
	char bp [3] = "BP";
	while(i<nsig && bpSig==-1) 
	{
		if(strstr(s[i].desc, bp)!=NULL)
			bpSig = i;
		i++;
	}
	if(bpSig == -1)
	{
		i=0;
		do
		{
			//printf("%ld\n", annotations[i]);
			annotateBeats(annotations[i]);
			i++;
		}while(annotations[i]!=0);
		printf("%ld\n", i);
		wfdbquit();
		exit(0);
	}

	//printf("%s\n\n", s[1].desc);

	/*if(strcmp(s[1].desc, "BP")!=0)
	{
		printf("no bp\n");
		//ann = annopen(record, a, 1);
		i=0;
		do
		{
			
			annotateBeats(annotations[i]);
			//printf("%d\n", i);
			i++;
		}while(annotations[i]!=0);
		//annotateBeats(i);
		wfdbquit();
		exit(0);
	}*/
	
	v = (WFDB_Sample *) calloc(nsig, sizeof(WFDB_Sample));

	readBp();
/*	int zeroCheck = 0;
	for(i=0; i<250; i++)
	{
		//printf("%ld ", bpSignal[i]);
		zeroCheck += bpSignal[i];
		if(zeroCheck < 0)
			zeroCheck*=-1;
	}	
	
	
	printf("%ld\n", zeroCheck);
	char bp [3] = "BP";
	if(zeroCheck <= 6 || strstr(s[1].desc, bp)==NULL)
	{
		//printf("Flatline\n");
		i=0;
		do
		{
			//printf("%ld\n", annotations[i]);
			annotateBeats(annotations[i]);
			i++;
		}while(annotations[i]!=0);
		printf("%ld\n", i);
		wfdbquit();
		exit(0);
	}*/
//	long start, end;
/*	annopen("set-p-atr/112", aTraining, 1);
	
	getann(0, &annot2);
	start = annot2.time;
	getann(0, &annot2);
	end = annot2.time;
	refAnns[0] = start;
	refAnns[1] = end;
	i=2;
	while(getann(0, &annot2)==0)
	{
		refAnns[i] = annot2.time;
		i++;
	}
	printf("ann:  %ld\n\n", i);*/
	//ann = annopen(record, a, 1);
/*	createTemplate(annotations[0], annotations[1]);
	start = annotations[0];
	end = annotations[1];

	findDistance(end-start);
*/





//	for(i=0; i<3; i++)
//		free(argv[i]);
//	free(refAnns);
//	free(template);
	//printf("%ld\n", *templateList[0]);
	compareBeats();

	for(i=0; i<numTemplates; i++)
		free(templateList[i]);
	free(templateList);
	free(finalTempLength);
	free(argv);
	free(annotations);
	free(annotationsBp);
	free(s);
	free(bpSignal);
	free(v);
	wfdbquit();
	exit(0);
}


void compareBeats()
{
	long i=0, index, j, k, distance, locDistance, minDistance= 500000, beat=-1;
	int annotated = 0;
	do
	{
		distance = 0;
		index = annotations[i];
		j=0;
		while(j< numTemplates && annotated == 0 )
		{
			for(k=1; k<finalTempLength[j]; k++)
			{
				//printf("%ld\n", *(templateList[0]));
				locDistance = bpSignal[index+k]- *(templateList[j]+k);
				
				if(locDistance < 0)
					locDistance *= -1;
				distance += locDistance;
				
			}
			if(distance < 1100)
			{
				/*beat = j;
				minDistance = distance;*/
				annotateBeats(index);
				annotated = 1;
			}
			
			distance = 0;
			j++;
		}
		annotated = 0;
		//printf("Distance: %d %d %d\n", i, beat, minDistance);	
		i++;
	}while(annotations[i]!=0); //possible break point if gqrs produces no beats


}

void readBp()
{
	long i=0, prev;
	getvec(v);
	prev = v[bpSig];
	while(getvec(v)>=0)
	{
		bpSignal[i] = v[bpSig]-prev;
		prev = v[bpSig];
		i++;

	}



}

void createTemplate(long start, long end)
{

	long i, j;
	template = (long*)calloc(end-start+1, sizeof(long));
	//printf("%ld %ld\n", start, end);
	j= start;
	for(i=0; i< end-start+1; i++)
	{
		template[i] = bpSignal[j];
		//printf("%ld, ", template[i]);
		//printf("%ld: %ld %ld\n", i, template[i], bpSignal[j]);
		j++;
	}
/*	printf("\n");
	int total = end - start +1;
	long old[500] = {0, -3, 1, -1, -2, 2, -4, 0, -1, -1, -4, 0, -1, -1, -4, 0, 1, -4, -1, 0, -3, 0, -5, 0, -2, -2, 0, -4, -1, -2, -2, -1, -3, 0, -2, -1, -2, -1, -2, 0, -2, -1, 1, 0, -1, 1, 2, 5, 7, 5, 12, 15, 18, 15, 22, 21, 24, 21, 24, 24, 24, 21, 23, 21, 18, 15, 18, 15, 11, 10, 7, 4, 3, 3, 1, -4, -3, -5, -4, -5, -7, -4, -5, -7, -4, -7, -2, -5, -4, -4, 0, -2, 0, -3, 1, 0, 0, -2, 3, 0, 0, 4, 0, -1, 1, 0, -1, -1, 0, -2, -3, -4, -4, -6, -7, -4, -12, -7, -10, -10, -12, -10, -9, -9, -9, -7, -7, -6, -7, -4, -2, -4, -2, 0, -1, 0, 1, 0, 2, 2, 2, 2, 3, 3, 0, 0, 4, 1, 0, 1, -1, 1, -2, 0, -2, -2, -3, 0, -4, -1, -5, -3, -1, -5, -2, -4, -1, -6, 0, -5, -3, -5, -2, -2, -5, -2, -3, -2, -4, 0, -1, -5, 1, -3, -3, -1, -2, -2, -3, 1, 0, -5, -1, -2, 0, -1, -1, -2, -2, -3, 2, -3, -2, 0, 1, -2, -1, -3, 2, -3, 0};
	for(i=0; i<end-start+1; i++)
	{
		template[i] = old[i];


	}*/



}

void findDistance(long templateLength)
{
	long i, j;
	long manDist, locDist, prev=0;
	for(i=0; i<150000; i++)
	{
		manDist = 0;
		//printf("distance\n\n");
		for(j=0; j< templateLength; j++)
		{
			//printf("%ld: %ld %ld\n", j, template[j], bpSignal[i+j]);
			locDist = bpSignal[i+j]-template[j];
			if(locDist < 0)
				locDist*=-1;
			manDist+=locDist;
		}
		//printf("%ld: %ld\n", i, manDist);
		if(manDist < 900 && i-prev > 60)
		{
			
			annotationsBp[annNum] = i;
			annNum++;
			prev = i;
			annotateBeats(i);
		}

	}
	printf("%ld\n", annNum);


}

//N(92060)/O(92060)
//V(135625)/O(135625)


void annotateBeats(WFDB_Time time){
	int i;
	//annot.aux = "100";	
	annot.anntyp = NORMAL;
	annot.chan = 0;
	annot.time = time;
	i = putann(0, &annot);
	if(i != 0)
		printf("missed ann: %ld\n", time);
	//printf("%d\n", annIndex);
	annIndex++;

}

