//Sarah Bass	

//redo so it clusters each record into several clusters and then add those centroids to overall
//template list.  cluster based on random or 1/3 of the way through or something
//at end output centroids.

#include <stdio.h>
#include <stdlib.h>
#include <wfdb/ecgcodes.h>
#include <wfdb/wfdb.h>


struct sample {
    struct sample *below; /* points to lower neighbor (next signal) */
    struct sample *next; /* pointers to neighbor (in time) */
    WFDB_Time time;	/* time of sample */
    int amp;	 /* value of signal at time of sample */
};
typedef struct sample Sample;

long* annotations;
WFDB_Annotation annot, annot2;
WFDB_Anninfo aTraining[1];
int mode = 0;
long annNum =0;
long* annotationsBp;
WFDB_Sample *v;
WFDB_Siginfo *s;
int nsig;
int signum = 0;
Sample *sigHead, *sigTail, *maxHead, *maxTail;
int* bpAtMax;
int* max, * min;
int* delay;
long* curMax;
char* record;
long* sum;
long* meanCount;
long currentTime = 0;
long* numMax;
long annIndex = 0;
double maxCount = 0;
FILE* fout;
int* original;
int* bpSignal;
long* template;
long** templateList;
long templateCount = 0;
int* templateLength;
long* refAnns;
int minLength = 4000;
int maxLength = 0;
int lastCluster = 0;
int sampfrq = 250;

long** templateRecordList;
long templateRecordCount = 0;
int* templateRecordLength;

#define NUMOFCLUSTERS 10
int hasCentroid [NUMOFCLUSTERS];
//int centroidMaxLength [NUMOFCLUSTERS] = {175, 190, 205, 215, 240, 1000};
long* numAnnPerRec;

int finalTempInd = 0;
int* finalTempLength;
long** finalTemplateList;
long** centroidList;  //stores centroids of each cluster
int* centroidLength; //stores length of centroid
int* clusters;  //stores index to templateList
int* clusterSize; //size of each cluster

void annotateBeats(WFDB_Time time);
void readBp();
void createTemplate(long start, long end);
int findDistance(int tempIndex, int centroidInd);
void filterSignal();
void kMeansPerRecord();
void kMeans();


int main(int argc, char **argv1)
{
	
	long i, j;
	int ann;
	fout = fopen("templates.csv", "w");
	WFDB_Anninfo a[2];
	//WFDB_Anninfo aTraining[1];
//	annotations = (WFDB_Time*)calloc(138000, sizeof(WFDB_Time));
//	record = argv1[2];
	aTraining[0].name = "atr"; aTraining[0].stat = WFDB_READ;


//	a[0].name = "qrs"; a[0].stat = WFDB_WRITE;	

	
//	annotationsBp = (WFDB_Time*)calloc(18750, sizeof(WFDB_Time));
	refAnns = (long*)calloc(18750, sizeof(long));
	bpSignal = (int*)calloc(10*sampfrq*60, sizeof(int));

	templateList = (long**)calloc(100*18750, sizeof(long*));
	finalTemplateList = (long**)calloc(100*10, sizeof(long*));
	finalTempLength = (int*)calloc(100*10, sizeof(int));
	templateLength = (int*)calloc(100*18750, sizeof(int));
	centroidList = (long**)calloc(NUMOFCLUSTERS, sizeof(long*));
	centroidLength = (int*)calloc(NUMOFCLUSTERS, sizeof(int));
	
	clusterSize = (int*)calloc(NUMOFCLUSTERS, sizeof(int));
	for(i=0; i<NUMOFCLUSTERS; i++)
	{
		centroidList[i] = (long*)calloc(500, sizeof(long));
		hasCentroid[i]= 0;
		clusterSize[i] = 1;
		
	}
	numAnnPerRec = (long*)calloc(100, sizeof(long));
	printf("done allocating\n");
	
	int rec = 100;
	char recnum[4];
	char annRecName[14],  recordName[10];
	strcpy(recordName, "set-p/");
	strcpy(annRecName, "set-p-atr/");
	printf("entering loop\n");
	while(rec < 200)
	{
		templateList = (long**)calloc(100*18750, sizeof(long*));
		for(i=0; i<NUMOFCLUSTERS; i++)
		{
			//centroidList[i] = (long*)calloc(500, sizeof(long));
			hasCentroid[i]= 0;
			clusterSize[i] = 1;
		
		}
		sprintf(recnum, "%d", rec);
		strcat(recordName, recnum);
		strcat(annRecName, recnum);
		//printf("%s\n", annRecName);
		
		nsig = isigopen(recordName, NULL, 0);

		s = (WFDB_Siginfo *)calloc(nsig, sizeof(WFDB_Siginfo));
		
		if (isigopen(recordName, s, nsig) != nsig)
		exit(1);
		//printf("signal open\n");
		annopen(annRecName, aTraining, 1);
		setifreq(sampfrq);

		i=0;
		while(getann(0, &annot2)==0)
		{
			refAnns[i] = annot2.time;
			i++;
		}
		numAnnPerRec[rec-100] = i;
		//printf("ann:  %ld\n\n", i);
		//wfdbquit();


		


		
		
		v = (WFDB_Sample *) calloc(nsig, sizeof(WFDB_Sample));

		readBp();
		int zeroCheck = 0, read;
		for(i=0; i<sampfrq; i++)
		{
			//printf("%ld ", bpSignal[i]);
			read = bpSignal[i];
			if(read < 0)
				read *= -1;
			zeroCheck += read;
		}	
	
		
		//printf("%s %ld\n", recordName, zeroCheck);

		if(zeroCheck > 400)
		{
			i=0;
			do
			{
		
				createTemplate(refAnns[i], refAnns[i+1]);
				i++;
			}while(i+1 < numAnnPerRec[rec-100]);
			wfdbquit();
			
			i=0;
			int k;
			//printf("total tmep: %d\n", numAnnPerRec[rec-100]);
			for(k=0; i<NUMOFCLUSTERS; k+=(numAnnPerRec[rec-100]/NUMOFCLUSTERS))
			{
				
				for(j=0; j< templateLength[k]; j++)
				{
					*(centroidList[i]+j) = *(templateList[k]+j);
				}
				
				centroidLength[i] = templateLength[k];
				i++;
			
			}
			
			
			clusters = (int*)calloc(numAnnPerRec[rec-100], sizeof(int));
			
			kMeansPerRecord();
			printf("done with kMeans: %d\n", rec);
			free(clusters);
			for(i=0; i<templateCount; i++)
			{
				free(templateList[i]);
			}
			templateCount = 0;
			
			free(templateList);
			


		}

		


		
		
	

		strcpy(recordName, "set-p/");
		strcpy(annRecName, "set-p-atr/");
		rec++;
		free(s);
		free(v);
	}
	printf("Template Count:  %ld\n", templateCount);
	
	
	
	printf("\n\n");

	for(i=0; i<finalTempInd; i++)
	{
		fprintf(fout, "%d, ", finalTempLength[i]);
		for(j=0; j< finalTempLength[i]; j++)
		{
			fprintf(fout, "%d,", *(finalTemplateList[i]+j));
			
		}
		fprintf(fout, "\n");
	}
/*	for(i=0; i<NUMOFCLUSTERS; i++)
	{
		j=0;
		do
		{
			printf("%d, ", *(centroidList[i]+j));
			j++;
		
		}while(j<centroidLength[i]);
		printf("\n");
		
	}*/



	//kMeans();

/*	for(i=0; i<6; i++)
		printf("cluster %d: %d\n", i, divLength[i]);*/
//	for(i=0; i<3; i++)
//		free(argv[i]);
	free(refAnns);


//	free(template);
	for(i=0; i<NUMOFCLUSTERS; i++)
		free(centroidList[i]);
	free(centroidList);
	
	printf("done with kmeans\n");
//	free(templateList);	
	free(templateLength);
//	free(argv);
//	free(annotations);
//	free(annotationsBp);
//	free(s);
	free(bpSignal);
//	free(v);
	wfdbquit();
	fclose(fout);
	exit(0);
}


void kMeansPerRecord()
{
	long changes, cycle = 0;
	int minDistance, i,j, distance, cluster, minLength;
	for(i=0; i<templateCount; i++)
	{		
		clusters[i] = -1;

	
	}
/*	printf("\n\n done printing\n\n");
	for(i=0; i<NUMOFCLUSTERS; i++)
	{
		printf("%d\n", i);
		for(j=0; j< centroidLength[i]; j++)
		{
			printf("%d, ", *(centroidList[i]+j));
		}
		printf("\n");
	}
	for(j=0; j< templateLength[i]; j++)
	{
		printf("%d, ", *(templateList[1]+j));
	}
	printf("\n");
*/	
	
	do
	{
		changes = 0;
		for(i=0; i<templateCount; i++)
		{
	
			minDistance = findDistance(i, 0);
			cluster = 0;
			for(j=1; j<NUMOFCLUSTERS; j++)
			{
				distance = findDistance(i, j);
				if(distance < minDistance)
				{
					minDistance = distance;
					cluster = j;
				}

			}
			
			if(cluster != clusters[i])
			{
				//printf("cluster: %d\n", cluster);
				if(clusters[i]!=-1)
				{
					if(templateLength[i] < centroidLength[clusters[i]])
						minLength = templateLength[i];
					else
						minLength = centroidLength[clusters[i]];
					for(j=0; j< minLength; j++)
						*(centroidList[clusters[i]]+j)-= *(templateList[i]+j);
					clusterSize[clusters[i]]--;
				}
				if(templateLength[i] < centroidLength[cluster]) //longer - didn't create another var
					minLength = templateLength[i];
				else
					minLength = centroidLength[cluster];
				
				for(j=0; j< minLength; j++)
				{
					if(*(templateList[i]+j)<100 && *(templateList[i]+j)>-100)
						*(centroidList[cluster]+j) += *(templateList[i]+j);
					
				}
				//printf("%d: %d %d\n", i, templateLength[i], *(templateList[i]));
				//printf("%d: %d \n", i, *(centroidList[cluster]));
				clusterSize[cluster]++;
				centroidLength[cluster] = minLength;
				clusters[i] = cluster;
				changes++;

				
			}

			

		}
		
		
		printf("cycle %ld\n", cycle);
		cycle++;

	}while(changes!=0);
	printf("done\n");
	for(i=0; i<NUMOFCLUSTERS; i++)
	{
		finalTemplateList[finalTempInd] = (long*)calloc(centroidLength[i], sizeof(long));
		finalTempLength[finalTempInd] = centroidLength[i];
		for(j=0; j<centroidLength[i]; j++)
		{
			*(finalTemplateList[finalTempInd]+j)= *(centroidList[i]+j)/clusterSize[i];
			/*if(j<5 && i==6)
			printf("%d, ", *(centroidList[i]+j));*/
		}
		//printf("\n");
		finalTempInd++;
	}

}

void kMeans()
{
	long changes, cycle = 0;
	int minDistance, i,j, distance, cluster, minLength;
	for(i=0; i<templateCount; i++)
	{		
		clusters[i] = -1;

	
	}
	//printf("\n\n done printing\n\n");
	
	do
	{
		changes = 0;
		for(i=0; i<templateCount; i++)
		{
	
			minDistance = findDistance(i, 0);
			cluster = 0;
			for(j=1; j<NUMOFCLUSTERS; j++)
			{
				distance = findDistance(i, j);
				if(distance < minDistance)
				{
					minDistance = distance;
					cluster = j;
				}

			}
			
			if(cluster != clusters[i])
			{
				//printf("cluster: %d\n", cluster);
				if(clusters[i]!=-1)
				{
					if(templateLength[i] < centroidLength[clusters[i]])
						minLength = templateLength[i];
					else
						minLength = centroidLength[clusters[i]];
					for(j=0; j< minLength; j++)
						*(centroidList[clusters[i]]+j)-= *(templateList[i]+j);
				}
				if(templateLength[i] > centroidLength[cluster]) //longer - didn't create another var
					minLength = templateLength[i];
				else
					minLength = centroidLength[cluster];
				for(j=0; j< minLength; j++)
					*(centroidList[cluster]+j) += *(templateList[i]+j);
				clusterSize[clusters[i]]--;
				clusterSize[cluster]++;
				clusters[i] = cluster;
				changes++;

				
			}

			

		}
		
		
		printf("cycle %ld\n", cycle);
		cycle++;

	}while(changes!=0);



}


void readBp()
{
	long i=0, prev;
	getvec(v);
	prev = v[1];
	while(getvec(v)>=0)
	{
		bpSignal[i] = v[1]-prev;
		prev = v[1];
		i++;

	}



}

void filterSignal()
{
	long i=0, k, sum;
	while(bpSignal[i+3]!=0)
	{
		sum = 0;
		for(k=0; k<4; k++)
			sum += bpSignal[i+k];
		bpSignal[i] = sum/4;
		i++;
	}



}


void createTemplate(long start, long end)
{

	long i, j;
	int tempLength=end-start;
	template = (long*)calloc(tempLength, sizeof(long));

	j= start;
	for(i=0; i< tempLength; i++)
	{
		template[i] = bpSignal[j];
		
		j++;
	}

	templateList[templateCount] = template;
	templateLength[templateCount] = tempLength;

	
	templateCount++;

}

int findDistance(int tempIndex, int centroidInd)
{
	long i, j;
	long manDist, locDist, prev=0;
	int shorterLength;
	
	manDist = 0;
		//printf("distance\n\n");
	if(templateLength[tempIndex]<centroidLength[centroidInd])
		shorterLength = templateLength[tempIndex];
	else
		shorterLength = centroidLength[centroidInd];
	for(j=0; j< shorterLength; j++)
	{
		//printf("%ld: %ld %ld\n", j, *(templateList[tempIndex]+j), *(centroidList[centroidInd]+j)/clusterSize[centroidInd]);
		locDist = *(templateList[tempIndex]+j)-(int)*(centroidList[centroidInd]+j)/clusterSize[centroidInd];
		if(locDist < 0)
			locDist*=-1;
		manDist+=locDist;
	}
	//printf("Distance %d, %d: %ld\n", tempIndex, centroidInd, manDist);

	return manDist;


}




void annotateBeats(WFDB_Time time){
	int i;
	//annot.aux = "100";	
	annot.anntyp = NORMAL;
	annot.chan = 0;
	annot.time = time;
	i = putann(0, &annot);
	if(i != 0)
		printf("missed ann: %ld\n", time);
	//printf("%d\n", annIndex);
	annIndex++;

}

